<template>
  <v-container fluid>
    <v-data-table
      :headers="headers"
      :items="projects"
      :server-items-length="projectsCount"
      :page="currPage"
      :items-per-page="currItemsPerPage"
      v-on:pagination="pagination"
    >
      <template v-slot:top>
        <v-toolbar flat color="white">
          <v-toolbar-title>Полезные дела</v-toolbar-title>
          <v-spacer></v-spacer>
          <v-dialog v-model="dialogDelete" max-width="500px" scrollable persistent>
            <template v-slot:activator="{ on }">
              <v-btn color="blue" dark class="mb-2 mr-4" v-on="on">Справочник</v-btn>
            </template>
            <v-card>
              <v-card-title>
                <span class="headline">Справочник</span>
              </v-card-title>

              <v-card-text>
                <v-container>
                  <v-row>
                    <v-col cols="12">
                      <v-select v-model="editedItem.category_id" :items="categoriesList" dense hide-details></v-select>
                    </v-col>
                    <DirectoryList v-if="categoriesList.length" title="Региональный проект"
                                   :parent-id="editedItem.category_id"
                                   :delete-func="deleteSubcategory"
                                   :list="categoriesList[editedItem.category_id - 1].subcategoriesList"/>
                    <DirectoryList title="Тип объекта" :delete-func="deleteType" :list="types"/>
                    <DirectoryList title="Ответственный" :delete-func="deleteResponsible" :list="responsibles"/>
                  </v-row>
                </v-container>
              </v-card-text>

              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="blue darken-1" text @click="close">Закрыть</v-btn>
              </v-card-actions>
            </v-card>
          </v-dialog>
          <v-dialog v-model="dialog" max-width="500px" scrollable persistent>
            <template v-slot:activator="{ on }">
              <v-btn color="primary" dark class="mb-2" v-on="on">Добавить</v-btn>
            </template>
            <v-card>
              <v-card-title>
                <span class="headline">{{ formTitle }}</span>
              </v-card-title>

              <v-card-text>
                <v-form
                  ref="edit"
                  v-model="valid"
                >
                  <v-container>
                    <v-row>
                      <v-col cols="12" v-if="postError">
                        <v-alert
                          dense
                          outlined
                          type="error"
                        >
                          {{postError}}
                        </v-alert>
                      </v-col>
                      <v-col cols="12">
                        <v-select v-model="editedItem.category_id" :rules="categoryRules" :items="categoriesList" dense
                                  label="Национальный проект"></v-select>
                      </v-col>
                      <v-col cols="12">
                        <v-select
                          v-model="editedItem.subcategory_id"
                          :items="categoriesList.length ? categoriesList[editedItem.category_id - 1].subcategoriesList : []"
                          :rules="subcategoryRules"
                          dense
                          :disabled="!editedItem.category_id"
                          label="Региональный проект"
                        >
                        </v-select>
                      </v-col>
                      <v-col cols="12" v-if="editedItem.subcategory_id === -1">
                        <v-text-field
                          v-model="editedItem.subcategoryNew"
                          :rules="subcategoryNewRules"
                          label="Новый рег. проект"
                          dense
                        ></v-text-field>
                      </v-col>
                      <v-col cols="12">
                        <v-select
                          v-model="editedItem.responsible_id"
                          :items="responsibles"
                          :rules="responsibleRules"
                          dense
                          label="Ответственный"
                        >
                        </v-select>
                      </v-col>
                      <v-col cols="12" v-if="editedItem.responsible_id === -1">
                        <v-text-field
                          v-model="editedItem.responsibleNew"
                          :rules="responsibleNewRules"
                          label="Новый ответственный"
                          dense
                        ></v-text-field>
                      </v-col>
                      <v-col cols="12">
                        <v-select
                          v-model="editedItem.type_id"
                          :items="types"
                          :rules="typeRules"
                          dense
                          label="Тип объекта"
                        >
                        </v-select>
                      </v-col>
                      <v-col cols="12" v-if="editedItem.type_id === -1">
                        <v-text-field
                          v-model="editedItem.typeNew"
                          :rules="typeNewRules"
                          dense
                          label="Новый тип объекта"
                        ></v-text-field>
                      </v-col>
                      <v-col cols="12">
                        <v-text-field v-model="editedItem.name" :rules="nameRules" dense
                                      label="Название"></v-text-field>
                      </v-col>
                      <v-col cols="12">
                        <v-select
                          v-model="editedItem.status"
                          :items="statuses"
                          :rules="statusRules"
                          dense
                          label="Статус"
                        >
                        </v-select>
                      </v-col>
                      <v-col cols="12" v-if="editedItem.status === 'Запланировано'">
                        <v-text-field
                          v-model="editedItem.end_date"
                          :rules="endDateRules"
                          dense
                          label="Плановый срок"
                        ></v-text-field>
                      </v-col>
                      <v-col cols="12">
                        <v-combobox
                          v-model="editedItem.address"
                          :rules="addressRules"
                          v-on:blur="onBlur"
                          dense
                          label="Адрес"
                          :items="items"
                          :search-input.sync="search"
                          no-filter
                          clearable
                          return-object
                        ></v-combobox>
                      </v-col>
                      <v-col cols="12">
                        <v-text-field
                          v-model="editedItem.email"
                          type="email"
                          :rules="emailRules"
                          dense
                          label="E-mail"
                        ></v-text-field>
                      </v-col>
                      <v-col cols="12">
                        <v-text-field
                          v-model="editedItem.website"
                          dense
                          label="Сайт"
                        ></v-text-field>
                      </v-col>
                      <v-col cols="12">
                        <v-text-field
                          v-model="editedItem.phone"
                          type="tel"
                          dense
                          label="Телефон"
                        ></v-text-field>
                      </v-col>
                      <v-col cols="12">
                        <v-textarea outlined v-model="editedItem.description" dense label="Описание"
                                    hide-details></v-textarea>
                      </v-col>
                      <v-col cols="12">
                        <v-file-input multiple v-model="editedItem.photos" label="Фотографии" dense outlined
                                      hide-details small-chips
                                      prepend-icon="mdi-camera"
                                      accept="image/*"></v-file-input>
                      </v-col>
                      <v-col cols="12" v-if="editedItem.id && photos.length">
                        <v-row>
                          <v-col cols="12" sm="6" md="4" v-for="(photo, index) in photos" :key="index"
                                 class="d-flex child-flex"
                          >
                            <v-hover v-slot:default="{ hover }">
                              <v-card flat tile class="d-flex">
                                <v-img
                                  :src="`${window.location.origin}/api/Containers/container-${editedItem.id}/download/${photo.name}`"
                                  contain
                                >
                                  <v-fade-transition>
                                    <v-overlay
                                      v-if="hover"
                                      absolute
                                      color="#036358"
                                    >
                                      <v-btn fab x-small dark color="error" @click="deleteImg(index)">
                                        <v-icon dark>
                                          mdi-close
                                        </v-icon>
                                      </v-btn>
                                    </v-overlay>
                                  </v-fade-transition>
                                </v-img>
                              </v-card>
                            </v-hover>
                          </v-col>
                        </v-row>
                      </v-col>
                    </v-row>
                  </v-container>
                </v-form>
              </v-card-text>

              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="blue darken-1" text @click="close">Отменить</v-btn>
                <v-btn color="blue darken-1" :loading="postStatus === 'loading'" text @click="save">Сохранить</v-btn>
              </v-card-actions>
            </v-card>
          </v-dialog>
        </v-toolbar>
      </template>
      <template v-slot:body.prepend>
        <tr>
          <td></td>
          <td>
            <v-text-field v-model="filterOpt.id" type="number" min="1" dense hide-details v-on:input="onInputFilter" clearable></v-text-field>
          </td>
          <td>
            <v-text-field v-model="filterOpt.name" type="text" dense hide-details v-on:input="onInputFilter" clearable></v-text-field>
          </td>
          <td>
            <v-select v-model="filterOpt.category_id" :items="categoriesList" dense
                      hide-details v-on:input="onInputFilter" clearable></v-select>
          </td>
          <td>
            <v-select v-if="categoriesList.length" v-model="filterOpt.subcategory_id"
                      :disabled="!categoriesList[filterOpt.category_id - 1]"
                      :items="categoriesList[filterOpt.category_id - 1] ? categoriesList[filterOpt.category_id - 1].subcategoriesList.slice(1) : []"
                      dense hide-details v-on:input="onInputFilter" clearable></v-select>
          </td>
          <td>
            <v-select v-model="filterOpt.type_id" :items="types.slice(1)" dense hide-details v-on:input="onInputFilter" clearable></v-select>
          </td>
          <td>
            <v-text-field v-model="filterOpt.address" type="text" dense hide-details v-on:input="onInputFilter" clearable></v-text-field>
          </td>
          <td>
            <v-select v-model="filterOpt.responsible_id" :items="responsibles.slice(1)" dense
                      hide-details v-on:input="onInputFilter" clearable></v-select>
          </td>
        </tr>
      </template>
      <template v-slot:item.actions="{ item }">
        <v-icon
          small
          class="mr-2"
          @click="cloneItem(item)"
        >
          mdi-arrange-bring-forward
        </v-icon>
        <v-icon
          small
          class="mr-2"
          @click="editItem(item)"
        >
          mdi-pencil
        </v-icon>
        <v-icon
          small
          @click="deleteItem(item)"
        >
          mdi-delete
        </v-icon>
      </template>
      <template v-slot:no-data>
        Нет результатов
      </template>
    </v-data-table>
  </v-container>
</template>

<script>
  import {mapActions, mapState} from 'vuex';
  import api from '../api';
  import DirectoryList from '../components/DirectoryList';

  export default {
    name: 'EditProjects',
    components: {DirectoryList},
    data: () => ({
      projectsCount: 0,
      postError: null,
      valid: true,
      dialog: false,
      dialogDelete: false,
      items: ['Адрес не найден'],
      search: null,
      filterOpt: {
        id: 0,
        name: '',
        category_id: 0,
        subcategory_id: 0,
        type_id: 0,
        responsible_id: 0,
        address: '',
      },
      headers: [
        {text: 'Действия', value: 'actions', sortable: false, width: 100},
        {text: 'Id', value: 'id', sortable: false, width: 100},
        {text: 'Название', value: 'name', sortable: false},
        {text: 'Нац. Проект', value: 'category.name', sortable: false},
        {text: 'Рег. Проект', value: 'subcategory.name', sortable: false},
        {text: 'Тип объекта', value: 'type.name', sortable: false},
        {text: 'Адрес', value: 'address', sortable: false},
        {text: 'Ответственный', value: 'responsible.name', sortable: false},
      ],
      statuses: ['Готово', 'Запланировано'],
      types: [
        {
          text: 'Другой',
          value: -1,
        },
      ],
      responsibles: [
        {
          text: 'Другой',
          value: -1,
        },
      ],
      editedIndex: -1,
      editedItem: {
        name: '',
        address: '',
        category_id: 1,
        subcategory_id: 0,
        subcategoryNew: '',
        email: '',
        website: '',
        phone: '',
        end_date: '',
        type_id: 0,
        typeNew: '',
        responsible_id: 0,
        responsibleNew: '',
        status: '',
        description: '',
        photos: [],
        deletedPhotos: [],
        addressSelected: false,
      },
      prevAddress: '',
      defaultItem: {
        name: '',
        address: '',
        category_id: 1,
        subcategory_id: 0,
        subcategoryNew: '',
        email: '',
        website: '',
        phone: '',
        end_date: '',
        status: '',
        type_id: 0,
        typeNew: '',
        responsible_id: 0,
        responsibleNew: '',
        description: '',
        photos: [],
        deletedPhotos: [],
        addressSelected: false,
      },
      isFocused: false,
      currPage: 1,
      currItemsPerPage: 10,
      categoriesList: [],
      postStatus: null,
      nameRules: [
        v => !!v || 'Введите название',
      ],
      categoryRules: [
        v => !!v || 'Выберите категорию',
      ],
      emailRules: [
        v => !!v === false || /.+@.+\..+/.test(v) || 'Неверный e-mail',
      ],
      statusRules: [
        v => !!v || 'Выберите статус',
      ],
      endDateRules: [
        v => !!v || 'Введите срок',
      ],
      subcategoryRules: [
        v => !!v || 'Выберите рег. проект',
      ],
      subcategoryNewRules: [
        v => !!v || 'Введите рег. проект',
      ],
      typeRules: [
        v => !!v || 'Выберите тип объекта',
      ],
      typeNewRules: [
        v => !!v || 'Введите тип объекта',
      ],
      addressRules: [
        v => !!v || 'Введите адрес',
      ],
      responsibleRules: [
        v => !!v || 'Выберите ответственного',
      ],
      responsibleNewRules: [
        v => !!v || 'Введите ответственного',
      ],
      timerId: null,
      window: window,
    }),
    computed: {
      formTitle() {
        return this.editedIndex === -1 ? 'Новый' : 'Изменить';
      },
      ...mapState('projects', [
        'projects',
        'photos',
      ]),
    },
    watch: {
      dialog(val) {
        val || this.close();
      },
      search(query) {
        if (query) {
          if (query !== this.editedItem.address) {
            this.editedItem.addressSelected = false;
            this.querySearch(query);
          } else {
            this.editedItem.addressSelected = true;
          }
        }
      },
      'editedItem.address': function() {
        if (!this.isFocused) return;
        this.editedItem.addressSelected = true;
      },
    },
    methods: {
      onInputFilter() {
        clearTimeout(this.timerId);
        this.timerId = setTimeout(() => {
          this.pagination({
            page: this.currPage,
            itemsPerPage: this.currItemsPerPage,
          });
        }, 300);
      },
      async deleteSubcategory(category_id, id, i) {
        await api.deleteSubcategory(id);
        this.categoriesList[category_id - 1].subcategoriesList.splice(i, 1);
      },
      async deleteType(id, i) {
        await api.deleteType(id);
        this.types.splice(i, 1);
      },
      async deleteResponsible(id, i) {
        await api.deleteResponsible(id);
        this.responsibles.splice(i, 1);
      },
      onFocus() {
        this.isFocused = true;
      },
      onBlur() {
        this.isFocused = false;
      },
      async querySearch() {
        // eslint-disable-next-line
        const result = await ymaps.suggest(
          this.search,
          {
            provider: {
              suggest: ((request) => {
                // eslint-disable-next-line
                return ymaps.suggest(`${process.env.VUE_APP_SEARCH}` + ', ' + request);
              }),
            },
            results: 5,
          });
        const places = [];
        result.forEach(el => {
          places.push(el.value);
        });
        this.items = places;
      },
      deleteImg(index) {
        this.editedItem.deletedPhotos.push(this.photos[index].name);
        this.photos.splice(index, 1);
      },
      pagination(opt) {
        const whereObj = {};
        if (this.filterOpt.id) whereObj.id = this.filterOpt.id;
        if (this.filterOpt.name) whereObj.name = {ilike: `%25${this.filterOpt.name}%25`};
        if (this.filterOpt.category_id) whereObj.category_id = this.filterOpt.category_id;
        if (this.filterOpt.subcategory_id) whereObj.subcategory_id = this.filterOpt.subcategory_id;
        if (this.filterOpt.type_id) whereObj.type_id = this.filterOpt.type_id;
        if (this.filterOpt.address) whereObj.address = {ilike: `%25${this.filterOpt.address}%25`};
        if (this.filterOpt.responsible_id) whereObj.responsible_id = this.filterOpt.responsible_id;

        let where;
        if (Object.keys(whereObj).length) {
          where = JSON.stringify(whereObj);
        }

        this.updateProjectsCount(where);
        this.getProjectsPage(opt.page, opt.itemsPerPage, where);
        this.currPage = opt.page;
        this.currItemsPerPage = opt.itemsPerPage;
      },
      async updateProjectsCount(where) {
        this.projectsCount = await api.getProjectsCount(where);
      },
      async cloneItem(item) {
        delete item.id;
        try {
          await api.createNewProject(item);
        } catch (e) {
          alert('Ошибка клонирования');
        }
        this.pagination({
          page: this.currPage,
          itemsPerPage: this.currItemsPerPage,
        });
      },
      editItem(item) {
        this.editedIndex = item.id;
        item.status = item.end_date ? 'Запланировано' : 'Готово';
        this.editedItem = Object.assign({}, item);
        this.editedItem.deletedPhotos = [];
        this.prevAddress = item.address;
        this.dialog = true;

        this.getPhotos(item.id);
      },
      async deleteItem(item) {
        if (confirm('Вы уверены, что хотите удалить?')) {
          await api.deleteProject(item.id);

          this.pagination({
            page: this.currPage,
            itemsPerPage: this.currItemsPerPage,
          });
        }
      },
      close() {
        this.dialog = false;
        if (this.dialogDelete) {
          this.pagination({
            page: this.currPage,
            itemsPerPage: this.currItemsPerPage,
          });
        }
        this.dialogDelete = false;
        setTimeout(() => {
          this.editedItem = Object.assign({}, this.defaultItem);
          this.prevAddress = '';
          this.editedIndex = -1;
          this.postError = null;
        }, 300);
      },
      async getCoords(query) {
        // eslint-disable-next-line
        const res = await ymaps.geocode(query, {
          results: 1,
        });

        const firstGeoObject = res.geoObjects.get(0);
        if (!firstGeoObject) {
          return null;
        }

        return firstGeoObject.geometry.getCoordinates();
      },
      uploadPhotos: async function(photos, id) {
        if (!photos || !photos.length) return;

        const data = new FormData();

        photos.forEach((photo, i) => {
          data.append(`images[${i}]`, photo);
        });
        return await api.uploadPhotos(id, data);
      },
      deletePhotos: async function(photos, id) {
        if (!photos || !photos.length) return;

        const deletePhotos = [];
        photos.forEach(photo => {
          deletePhotos.push(api.deletePhoto(id, photo));
        });
        return await Promise.all(deletePhotos);
      },
      async save() {
        const project = this.editedItem;
        try {
          if (!this.$refs.edit.validate()) return;
          if (!project.addressSelected) {
            this.postError = 'Адрес должен быть выбран из предложенных';
            this.postStatus = 'error';
            return;
          }

          this.postStatus = 'loading';
          if (this.prevAddress !== this.editedItem.address) {
            const coords = await this.getCoords(project.address);
            if (!coords) {
              this.postError = 'Неверный адрес, введите другой';
              this.postStatus = 'error';
              return;
            }
            project.latitude = coords[0];
            project.longitude = coords[1];
          }

          // new subcategory
          if (project.subcategory_id === -1) {
            project.subcategory_id = (await api.createNewSubcategory({
              name: project.subcategoryNew,
              category_id: project.category_id,
            })).id;
            this.categoriesList[project.category_id - 1].subcategoriesList.push({
              text: project.subcategoryNew,
              value: project.subcategory_id,
            });
          }

          // new responsible
          if (project.responsible_id === -1) {
            project.responsible_id = (await api.createNewResponsible({
              name: project.responsibleNew,
            })).id;
            this.responsibles.push({
              text: project.responsibleNew,
              value: project.responsible_id,
            });
          }

          // new type
          if (project.type_id === -1) {
            project.type_id = (await api.createNewType({
              name: project.typeNew,
            })).id;
            this.types.push({
              text: project.typeNew,
              value: project.type_id,
            });
          }

          if (project.status === 'Готово') {
            delete project.end_date;
          }

          if (this.editedIndex > -1) {
            delete project.category;
            delete project.subcategory;
            delete project.responsible;
            delete project.type;

            await api.updateProject(project);
            await this.uploadPhotos(project.photos, project.id);
            await this.deletePhotos(project.deletedPhotos, project.id);
          } else {
            const res = await api.createNewProject(project);
            await this.uploadPhotos(project.photos, res.id);
          }
        } catch (e) {
          this.postError = e.message;
          this.postStatus = 'error';
          return;
        }

        this.postStatus = 'success';
        this.pagination({
          page: this.currPage,
          itemsPerPage: this.currItemsPerPage,
        });
        this.close();
      },
      getProjectsPage(page, count, where) {
        let filter;
        if (count === -1) {
          filter = `{"include": ["category", "subcategory", "type", "responsible"], "order": "id DESC"${where ? `, "where": ${where}` : ''}}`;
        } else {
          filter = `{"include": ["category", "subcategory", "type", "responsible"], "order": "id DESC", "offset": "${(page - 1) * count}", "limit": "${count}"${where ? `, "where": ${where}` : ''}}`;
        }

        this.getProjects(filter);
      },
      async loadCategories() {
        const categories = await api.getCategoriesWithSubcategories();
        const categoriesList = [];
        categories.forEach(category => {
          const categoryEl = {
            text: category.name,
            value: category.id,
            subcategoriesList: [
              {
                text: 'Другой',
                value: -1,
              },
            ],
          };

          category.subcategories.forEach(subcategory => {
            categoryEl.subcategoriesList.push({
              text: subcategory.name,
              value: subcategory.id,
            });
          });

          categoriesList.push(categoryEl);
        });

        this.categoriesList = categoriesList;
      },
      async loadResponsibles() {
        const responsibles = await api.getResponsibles();
        responsibles.forEach(responsible => {
          this.responsibles.push({
            text: responsible.name,
            value: responsible.id,
          });
        });
      },
      async loadTypes() {
        const types = await api.getTypes();
        types.forEach(type => {
          this.types.push({
            text: type.name,
            value: type.id,
          });
        });
      },
      ...mapActions('projects', [
        'getProjects',
        'getPhotos',
      ]),
    },
    async created() {
      this.updateProjectsCount();
      this.getProjectsPage(1, 10);

      this.loadCategories();
      this.loadTypes();
      this.loadResponsibles();
    },
  };
</script>

